package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.DEDataChg;
import com.sa.ibiz.demo.demo.service.DEDataChgService;
import com.sa.ibiz.demo.demo.service.dto.DEDataChgSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/dedatachg")
public class DEDataChgResource
{
	@Autowired
	private DEDataChgService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<DEDataChg> get(@Validated @PathVariable String id){
		DEDataChg data=new DEDataChg();
		data.setDedatachgid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("实体数据变更[get]操作发生错误","DEDataChg",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<DEDataChg> update(@Validated @RequestBody DEDataChg data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更[update]操作发生错误","DEDataChg",data.getDedatachgid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<DEDataChg> create(@Validated @RequestBody DEDataChg data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更[create]操作发生错误","DEDataChg",data.getDedatachgid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<DEDataChg> getDraft(@Validated @RequestBody DEDataChg data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更[getDraft]操作发生错误","DEDataChg","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<DEDataChg> remove(@Validated @RequestBody DEDataChg data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更[remove]操作发生错误","DEDataChg",data.getDedatachgid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<DEDataChg> checkKey(@Validated @RequestBody DEDataChg data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更[checkKey]操作发生错误","DEDataChg",data.getDedatachgid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<DEDataChg>> searchDefaultPage(@Validated @RequestBody DEDataChgSearchFilter filter){
		Page<DEDataChg> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<DEDataChg>> listDefault(@Validated @RequestBody DEDataChgSearchFilter filter){
		List<DEDataChg> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
